// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'DataConv.pas' rev: 6.00

#ifndef DataConvHPP
#define DataConvHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <DateUtil.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Dataconv
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TDataType { dtString, dtInteger, dtFloat, dtDateTime, dtDate, dtTime, dtBoolean };
#pragma option pop

#pragma option push -b-
enum TTimeFormat { tfHHMMSS, tfHMMSS, tfHHMM, tfHMM };
#pragma option pop

class DELPHICLASS TDateTimeFormat;
class PASCALIMPLEMENTATION TDateTimeFormat : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	System::SmallString<7>  FAMString;
	System::SmallString<7>  FPMString;
	Dateutil::TDateOrder FDateOrder;
	TTimeFormat FTimeFormat;
	char FTimeSeparator;
	char FDateSeparator;
	bool FLongDate;
	bool FFourDigitYear;
	bool FLeadingZero;
	AnsiString __fastcall GetAMString();
	void __fastcall SetAMString(const AnsiString Value);
	AnsiString __fastcall GetPMString();
	void __fastcall SetPMString(const AnsiString Value);
	
protected:
	virtual AnsiString __fastcall GetDateMask();
	virtual AnsiString __fastcall GetTimeMask();
	virtual AnsiString __fastcall GetMask();
	
public:
	__fastcall TDateTimeFormat(void);
	__fastcall virtual ~TDateTimeFormat(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	virtual void __fastcall ResetDefault(void);
	__property AnsiString DateMask = {read=GetDateMask};
	__property AnsiString TimeMask = {read=GetTimeMask};
	__property AnsiString Mask = {read=GetMask};
	
__published:
	__property AnsiString AMString = {read=GetAMString, write=SetAMString};
	__property AnsiString PMString = {read=GetPMString, write=SetPMString};
	__property Dateutil::TDateOrder DateOrder = {read=FDateOrder, write=FDateOrder, nodefault};
	__property TTimeFormat TimeFormat = {read=FTimeFormat, write=FTimeFormat, nodefault};
	__property char TimeSeparator = {read=FTimeSeparator, write=FTimeSeparator, nodefault};
	__property char DateSeparator = {read=FDateSeparator, write=FDateSeparator, nodefault};
	__property bool LongDate = {read=FLongDate, write=FLongDate, default=0};
	__property bool FourDigitYear = {read=FFourDigitYear, write=FFourDigitYear, default=1};
	__property bool LeadingZero = {read=FLeadingZero, write=FLeadingZero, default=0};
};


class DELPHICLASS TConverter;
class PASCALIMPLEMENTATION TConverter : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	AnsiString FData;
	System::SmallString<15>  FTextValues[2];
	TDataType FDataType;
	TDateTimeFormat* FDateTimeFormat;
	Sysutils::TFloatFormat FFloatFormat;
	int FPrecision;
	int FDigits;
	bool FRaiseOnError;
	Classes::TNotifyEvent FOnChange;
	void __fastcall SetDataType(TDataType Value);
	void __fastcall SetDateTimeFormat(TDateTimeFormat* Value);
	TDateTimeFormat* __fastcall GetDateTimeFormat(void);
	AnsiString __fastcall GetString();
	void __fastcall SetString(const AnsiString Value);
	System::TDateTime __fastcall GetDateTime(void);
	AnsiString __fastcall GetBoolValues(int Index);
	void __fastcall SetBoolValues(int Index, const AnsiString Value);
	void __fastcall CheckDataType(void);
	AnsiString __fastcall BoolToStr(bool Value);
	AnsiString __fastcall FloatToString(double Value);
	AnsiString __fastcall DateTimeToString(System::TDateTime Value);
	
protected:
	DYNAMIC void __fastcall Change(void);
	virtual bool __fastcall GetAsBoolean(void);
	virtual System::TDateTime __fastcall GetAsDateTime(void);
	virtual System::TDateTime __fastcall GetAsDate(void);
	virtual System::TDateTime __fastcall GetAsTime(void);
	virtual double __fastcall GetAsFloat(void);
	virtual int __fastcall GetAsInteger(void);
	virtual AnsiString __fastcall GetAsString();
	virtual void __fastcall SetAsBoolean(bool Value);
	virtual void __fastcall SetAsDateTime(System::TDateTime Value);
	virtual void __fastcall SetAsDate(System::TDateTime Value);
	virtual void __fastcall SetAsTime(System::TDateTime Value);
	virtual void __fastcall SetAsFloat(double Value);
	virtual void __fastcall SetAsInteger(int Value);
	virtual void __fastcall SetAsString(const AnsiString Value);
	
public:
	__fastcall virtual TConverter(Classes::TComponent* AOwner);
	__fastcall virtual ~TConverter(void);
	void __fastcall Clear(void);
	virtual bool __fastcall IsValidChar(char Ch);
	__property bool AsBoolean = {read=GetAsBoolean, write=SetAsBoolean, nodefault};
	__property System::TDateTime AsDateTime = {read=GetAsDateTime, write=SetAsDateTime};
	__property System::TDateTime AsDate = {read=GetAsDate, write=SetAsDate};
	__property System::TDateTime AsTime = {read=GetAsTime, write=SetAsTime};
	__property double AsFloat = {read=GetAsFloat, write=SetAsFloat};
	__property int AsInteger = {read=GetAsInteger, write=SetAsInteger, nodefault};
	__property AnsiString AsString = {read=GetAsString, write=SetAsString};
	
__published:
	__property TDataType DataType = {read=FDataType, write=SetDataType, default=0};
	__property TDateTimeFormat* DateTimeFormat = {read=GetDateTimeFormat, write=SetDateTimeFormat};
	__property int Digits = {read=FDigits, write=FDigits, default=2};
	__property AnsiString DisplayFalse = {read=GetBoolValues, write=SetBoolValues, index=0};
	__property AnsiString DisplayTrue = {read=GetBoolValues, write=SetBoolValues, index=1};
	__property Sysutils::TFloatFormat FloatFormat = {read=FFloatFormat, write=FFloatFormat, default=0};
	__property int Precision = {read=FPrecision, write=FPrecision, default=15};
	__property bool RaiseOnError = {read=FRaiseOnError, write=FRaiseOnError, default=0};
	__property AnsiString Text = {read=GetString, write=SetAsString};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Dataconv */
using namespace Dataconv;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// DataConv
