// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'RXSpin.pas' rev: 6.00

#ifndef RXSpinHPP
#define RXSpinHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <SysUtils.hpp>	// Pascal unit
#include <Menus.hpp>	// Pascal unit
#include <StdCtrls.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <ExtCtrls.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <ComCtrls.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Rxspin
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TSpinButtonState { sbNotDown, sbTopDown, sbBottomDown };
#pragma option pop

class DELPHICLASS TRxSpinButton;
class PASCALIMPLEMENTATION TRxSpinButton : public Controls::TGraphicControl 
{
	typedef Controls::TGraphicControl inherited;
	
private:
	TSpinButtonState FDown;
	Graphics::TBitmap* FUpBitmap;
	Graphics::TBitmap* FDownBitmap;
	bool FDragging;
	bool FInvalidate;
	Graphics::TBitmap* FTopDownBtn;
	Graphics::TBitmap* FBottomDownBtn;
	Extctrls::TTimer* FRepeatTimer;
	Graphics::TBitmap* FNotDownBtn;
	TSpinButtonState FLastDown;
	Controls::TWinControl* FFocusControl;
	Classes::TNotifyEvent FOnTopClick;
	Classes::TNotifyEvent FOnBottomClick;
	void __fastcall TopClick(void);
	void __fastcall BottomClick(void);
	void __fastcall GlyphChanged(System::TObject* Sender);
	Graphics::TBitmap* __fastcall GetUpGlyph(void);
	Graphics::TBitmap* __fastcall GetDownGlyph(void);
	void __fastcall SetUpGlyph(Graphics::TBitmap* Value);
	void __fastcall SetDownGlyph(Graphics::TBitmap* Value);
	void __fastcall SetDown(TSpinButtonState Value);
	void __fastcall SetFocusControl(Controls::TWinControl* Value);
	void __fastcall DrawAllBitmap(void);
	void __fastcall DrawBitmap(Graphics::TBitmap* ABitmap, TSpinButtonState ADownState);
	void __fastcall TimerExpired(System::TObject* Sender);
	HIDESBASE MESSAGE void __fastcall CMEnabledChanged(Messages::TMessage &Message);
	
protected:
	virtual void __fastcall Paint(void);
	DYNAMIC void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseMove(Classes::TShiftState Shift, int X, int Y);
	DYNAMIC void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, int X, int Y);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	
public:
	__fastcall virtual TRxSpinButton(Classes::TComponent* AOwner);
	__fastcall virtual ~TRxSpinButton(void);
	__property TSpinButtonState Down = {read=FDown, write=SetDown, default=0};
	
__published:
	__property DragCursor  = {default=-12};
	__property DragMode  = {default=0};
	__property Enabled  = {default=1};
	__property Visible  = {default=1};
	__property Graphics::TBitmap* DownGlyph = {read=GetDownGlyph, write=SetDownGlyph};
	__property Graphics::TBitmap* UpGlyph = {read=GetUpGlyph, write=SetUpGlyph};
	__property Controls::TWinControl* FocusControl = {read=FFocusControl, write=SetFocusControl};
	__property ShowHint ;
	__property ParentShowHint  = {default=1};
	__property Anchors  = {default=3};
	__property Constraints ;
	__property DragKind  = {default=0};
	__property Classes::TNotifyEvent OnBottomClick = {read=FOnBottomClick, write=FOnBottomClick};
	__property Classes::TNotifyEvent OnTopClick = {read=FOnTopClick, write=FOnTopClick};
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnStartDrag ;
	__property OnEndDock ;
	__property OnStartDock ;
};


#pragma option push -b-
enum TValueType { vtInt, vtFloat, vtHex };
#pragma option pop

#pragma option push -b-
enum TSpinButtonKind { bkStandard, bkDiagonal };
#pragma option pop

class DELPHICLASS TRxSpinEdit;
class PASCALIMPLEMENTATION TRxSpinEdit : public Stdctrls::TCustomEdit 
{
	typedef Stdctrls::TCustomEdit inherited;
	
private:
	Classes::TAlignment FAlignment;
	Extended FMinValue;
	Extended FMaxValue;
	Extended FIncrement;
	Byte FDecimal;
	bool FChanging;
	bool FEditorEnabled;
	TValueType FValueType;
	TRxSpinButton* FButton;
	Controls::TWinControl* FBtnWindow;
	bool FArrowKeys;
	Classes::TNotifyEvent FOnTopClick;
	Classes::TNotifyEvent FOnBottomClick;
	TSpinButtonKind FButtonKind;
	Comctrls::TCustomUpDown* FUpDown;
	TSpinButtonKind __fastcall GetButtonKind(void);
	void __fastcall SetButtonKind(TSpinButtonKind Value);
	void __fastcall UpDownClick(System::TObject* Sender, Comctrls::TUDBtnType Button);
	int __fastcall GetMinHeight(void);
	void __fastcall GetTextHeight(int &SysHeight, int &Height);
	Extended __fastcall GetValue(void);
	Extended __fastcall CheckValue(Extended NewValue);
	int __fastcall GetAsInteger(void);
	bool __fastcall IsIncrementStored(void);
	bool __fastcall IsMaxStored(void);
	bool __fastcall IsMinStored(void);
	bool __fastcall IsValueStored(void);
	void __fastcall SetArrowKeys(bool Value);
	void __fastcall SetAsInteger(int NewValue);
	void __fastcall SetValue(Extended NewValue);
	void __fastcall SetValueType(TValueType NewType);
	void __fastcall SetDecimal(Byte NewValue);
	int __fastcall GetButtonWidth(void);
	void __fastcall RecreateButton(void);
	void __fastcall ResizeButton(void);
	void __fastcall SetEditRect(void);
	void __fastcall SetAlignment(Classes::TAlignment Value);
	HIDESBASE MESSAGE void __fastcall WMSize(Messages::TWMSize &Message);
	HIDESBASE MESSAGE void __fastcall CMEnter(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMExit(Messages::TWMNoParams &Message);
	MESSAGE void __fastcall WMPaste(Messages::TWMNoParams &Message);
	MESSAGE void __fastcall WMCut(Messages::TWMNoParams &Message);
	HIDESBASE MESSAGE void __fastcall CMCtl3DChanged(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMEnabledChanged(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMFontChanged(Messages::TMessage &Message);
	HIDESBASE MESSAGE void __fastcall CMBiDiModeChanged(Messages::TMessage &Message);
	
protected:
	DYNAMIC void __fastcall Change(void);
	virtual bool __fastcall IsValidChar(char Key);
	virtual void __fastcall UpClick(System::TObject* Sender);
	virtual void __fastcall DownClick(System::TObject* Sender);
	DYNAMIC void __fastcall KeyDown(Word &Key, Classes::TShiftState Shift);
	DYNAMIC void __fastcall KeyPress(char &Key);
	virtual void __fastcall CreateParams(Controls::TCreateParams &Params);
	virtual void __fastcall CreateWnd(void);
	
public:
	__fastcall virtual TRxSpinEdit(Classes::TComponent* AOwner);
	__fastcall virtual ~TRxSpinEdit(void);
	__property int AsInteger = {read=GetAsInteger, write=SetAsInteger, default=0};
	__property Text ;
	
__published:
	__property Classes::TAlignment Alignment = {read=FAlignment, write=SetAlignment, default=0};
	__property bool ArrowKeys = {read=FArrowKeys, write=SetArrowKeys, default=1};
	__property TSpinButtonKind ButtonKind = {read=FButtonKind, write=SetButtonKind, default=1};
	__property Byte Decimal = {read=FDecimal, write=SetDecimal, default=2};
	__property bool EditorEnabled = {read=FEditorEnabled, write=FEditorEnabled, default=1};
	__property Extended Increment = {read=FIncrement, write=FIncrement, stored=IsIncrementStored};
	__property Extended MaxValue = {read=FMaxValue, write=FMaxValue, stored=IsMaxStored};
	__property Extended MinValue = {read=FMinValue, write=FMinValue, stored=IsMinStored};
	__property TValueType ValueType = {read=FValueType, write=SetValueType, default=0};
	__property Extended Value = {read=GetValue, write=SetValue, stored=IsValueStored};
	__property AutoSelect  = {default=1};
	__property AutoSize  = {default=1};
	__property BorderStyle  = {default=1};
	__property Color  = {default=-2147483643};
	__property Ctl3D ;
	__property DragCursor  = {default=-12};
	__property DragMode  = {default=0};
	__property Enabled  = {default=1};
	__property Font ;
	__property Anchors  = {default=3};
	__property BiDiMode ;
	__property Constraints ;
	__property DragKind  = {default=0};
	__property ParentBiDiMode  = {default=1};
	__property ImeMode  = {default=3};
	__property ImeName ;
	__property MaxLength  = {default=0};
	__property ParentColor  = {default=0};
	__property ParentCtl3D  = {default=1};
	__property ParentFont  = {default=1};
	__property ParentShowHint  = {default=1};
	__property PopupMenu ;
	__property ReadOnly  = {default=0};
	__property ShowHint ;
	__property TabOrder  = {default=-1};
	__property TabStop  = {default=1};
	__property Visible  = {default=1};
	__property Classes::TNotifyEvent OnBottomClick = {read=FOnBottomClick, write=FOnBottomClick};
	__property Classes::TNotifyEvent OnTopClick = {read=FOnTopClick, write=FOnTopClick};
	__property OnChange ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnDragDrop ;
	__property OnDragOver ;
	__property OnEndDrag ;
	__property OnEnter ;
	__property OnExit ;
	__property OnKeyDown ;
	__property OnKeyPress ;
	__property OnKeyUp ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
	__property OnStartDrag ;
	__property OnContextPopup ;
	__property OnMouseWheelDown ;
	__property OnMouseWheelUp ;
	__property OnEndDock ;
	__property OnStartDock ;
public:
	#pragma option push -w-inl
	/* TWinControl.CreateParented */ inline __fastcall TRxSpinEdit(HWND ParentWindow) : Stdctrls::TCustomEdit(ParentWindow) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Rxspin */
using namespace Rxspin;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// RXSpin
